#ifndef VIEW_H
#define VIEW_H

#include <vector>

#include "iterator.h"
#include "Cluster.h"
//#include "../database/DataEngine.h"

namespace cluster {


//class DataEngine;


/**
	A View is a kind of screenshot of the clusterization
	at the current time
*/
class View
{
  public:
	typedef ClusterIterator iterator;

	// wanna do another kind of view ?
  protected:
	//const DataEngine *engine;
	std::vector<Cluster *>  view;

	//! Protected constructor...
  public:

	View(){}

	virtual ~View();
	/*View(const DataEngine& dataEngine)
	{
		engine = &dataEngine;
	}*/

	// customization of the view


	//! Perform a simulation
	//double simulate();


	//! Size of the View (number of clusters)
	inline unsigned size() const {
		return view.size();
	}

	//! Add a cluster to the view
	inline View& add(Cluster& c) {
		// test the cluster we want to add is OK
		for (std::vector<Cluster *>::iterator iter = view.begin(); iter != view.end(); ++iter)
		{
			if (c == **iter)
				return *this;
		}
		view.push_back(&c);
		return *this;
	}

	//! Nice visu
	inline View& operator<<(Cluster& c) { return add(c); }


	// iterator information
	inline iterator begin() { return ClusterIterator(view.begin()); }
	inline iterator end()   { return ClusterIterator(view.end());   }


	// movment on view/clusters

	inline void move(ClusterIterator src , ClusterIterator dest, GroupIterator g) {
		dest->add(g);
		src->remove(g);
	}

	inline View& add(ClusterIterator c, const Group& g) {
		Group *ptr = const_cast<Group *>(&g);
		c->add(ptr);
		return *this;
	}
	inline View& add(ClusterIterator c, GroupIterator g) {
		c->add(g.ptr());
		return *this;
	}

	inline void remove(ClusterIterator c) {
		std::vector<Cluster *>::iterator iter;
		if ((iter=std::find(view.begin(), view.end(), c.ptr())) != view.end())
		{
			*iter = 0;
		}
	}

	inline void remove(ClusterIterator c, const Group& g) {
		Group *ptr = &(const_cast<Group&>(g));
		c->remove(ptr);
	}

	inline void remove(ClusterIterator c, GroupIterator g) {
		c->remove(g.ptr());
	}

	friend std::ostream& operator<<(std::ostream& str, const View& v);

};


std::ostream& operator<<(std::ostream& str, const View& v);


/**
	Create a temporary view
	It's a vision of a subsystem at an instant t
*/
class ViewTemp : public View
{
  public:
	ViewTemp()  {}
	~ViewTemp() {}
	
	ViewTemp(const View& v) : view(v.view) {}
};



}


#endif
