#include <list>
#include <iostream>
#include "View.h"

using namespace std;

namespace cluster {

View::~View()
{
}


std::ostream& operator<<(std::ostream& str, const View& v)
{
	str << "View= " << endl;
	list<Cluster *>::const_iterator iter = v.view.begin();
	for (;iter!= v.view.end();++iter)
	   str << **iter << endl;
	return str;
}

View::iterator View::randCluster()
{
	iterator iter(begin());
	for(int i=0; i<rand(0,view.size()); ++i,++iter);
	return iter;
}


double View::computeRegressionModel()
{
	for (View::iterator iter = begin(); iter != end(); ++iter)
	{
		list<unsigned> ids;
		for (Cluster::iterator jter = iter->begin(); jter != iter->end(); ++jter)
		{
			if(jter.ptr())
			for (Group::iterator kter = jter->begin(); kter != jter->end(); ++kter)
			{
				if( kter.ptr() )
					ids.push_back(kter->id);
			}
		}
		engine->computeRegression(ids,iter->id);
	}
	return 0.0;
}

double View::computeError(const Observation & obs, const Cluster & cluster)
{
	return engine->error(obs.id,cluster.id);
}

double View::computeGlobalError()
{
	double error = 0.0;
	for (View::iterator iter = begin(); iter != end(); ++iter)
	{
		if( iter.ptr() )
		for (Cluster::iterator jter = iter->begin(); jter != iter->end(); ++jter)
		{
			if( jter.ptr() )
			for (Group::iterator kter = jter->begin(); kter != jter->end(); ++kter)
			{
				if(kter.ptr())
					error += computeError(*kter,*iter);
			}
		}
	}

	return error;
}

}
