#include <algorithm>
#include <string>
#include <iostream>

#include "cluster/Cluster.h"
#include "cluster/View.h"
#include "database/Global.h"

using namespace std;
using namespace cluster;
using namespace database;

int main(int, char **)
{
	DataBase data("../housing.data");
	DataEngine dataEngine(data,0,3,7);
	View	v(dataEngine);
	Cluster c1, c2;
	Group   g1,g2, g3;

	Observation obs[13] = {1,2,3,4,5,6,7,8,9,10,11,12,13};
	Observation o(42);

	for(unsigned i=0;i<10;i+=3)
	{
		g1.add(obs+i);
		g2.add(obs+i+1);
		g3.add(obs+i+2);
	}

	// create clusters
	cout << "cluster1 = " << endl;
	c1.add(&g1);
	c1.add(obs+5);
	c1.add(obs+6);
	c1.add(&g2);
	c1.add(&o);
	c1.add(obs+1);
	c1.add(obs+2);
	c1.add(obs+3);


	cout << "cluster2 = " << endl;
	c2.add(&g3);
	c2.add(&g1);
	c2.add(&g2);
	c2.add(&o);
	cout << endl << endl;


	// add the clusters in a view
	v << c1 << c2;


	// try to remove a group in a cluster...
	cout << "Remove " << g3 << "  in the second cluster" << endl;
	c2.remove(&g3);

	cout << endl << endl;
	cout << "-----= Work within ClusterIterator/GroupIterator =-----" << endl;


	// show the result
	for (View::iterator iter = v.begin(); iter != v.end(); ++iter)
		cout << *iter << endl;


	// Try all iterator with one full-loop :)
	for (View::iterator iter = v.begin(); iter != v.end(); ++iter)
	{
		cout << "Cluster..." << endl;
		for (Cluster::iterator jter = iter->begin(); jter != iter->end(); ++jter)
		{
			if (jter.ptr()==0)
				continue;

			cout << "Group... [";
			for (Group::iterator kter = jter->begin(); kter != jter->end(); ++kter)
			{
				cout << *kter << ',';
			}
			cout << ']'<< endl;
		}
	}

	cout << "Erase nested groups in clusters..." << endl;
	// erase nested groups in clusters
	unsigned i=0;
	for (View::iterator iter = v.begin(); iter != v.end(); ++iter)
	{
		cout << '#' << (++i) << endl;
		unsigned j = 0;
		for (Cluster::iterator jter = iter->begin(); jter != iter->end(); ++jter)
		{
			// The structure need this test :/ (i should add this into operator++ in iterators... but
			// the end should be at least tricky)
			if (jter.ptr() == 0)
				continue;

			cout << (++j) << "  -------- " << *jter << endl;
			if (jter->size() <= 1)
			{
				// remove (*jter) group from (*iter) cluster
				cout << ">>> trying to remove " << *jter << endl;
				iter->remove(jter);
			}
		}
	}



	cout << "then print..." << endl;
	for (View::iterator iter = v.begin(); iter != v.end(); ++iter)
		cout << *iter << endl;
		
	cout << v.simulate() << endl;

	return 0;
}

