#ifndef _DATAENGINE_HPP_
#define _DATAENGINE_HPP_

#include <list>
#include "DataBase.h"
#include "RegressionStorage.h"

namespace database {


class DataEngine
{
	private:
		const DataBase * dataBase;
		DataEngine() {}
		RegressionStorage * storage;
		unsigned index;
		unsigned dimension;

	public:
		DataEngine(const DataBase & _dataBase,
							 unsigned _index,
							 unsigned K,
							 unsigned sizeOfStorage)
		{
				index=_index;
				dataBase=&_dataBase;
				dimension = dataBase->getDimension();
				storage = new RegressionStorage(K,sizeOfStorage);
		}

		void computeRegression(std::list<unsigned> listObs, unsigned K) const;

		double error(unsigned obsId, unsigned K) const;

		~DataEngine()
		{
			delete storage;
		}
};

}

#endif

